/* AMX Mod X
*  IP_gag
*
*  by Mak-Di
* 
*
* 
*
*/

#include <amxmodx>
new IPs[50][32]
new ipgaged[64] = "addons/amxx/configs/ipgaged.cfg"
new logs[200][70]
new log_file[64] = "addons/amxx/logs/ipgaged.log"

public plugin_init()
{
	register_plugin("IP gag","0.2","Mak-Di") 
	register_concmd("amx_gagip","cmdgag",ADMIN_LEVEL_A,"<IP address> - Gag this IP") 
	register_concmd("amx_gaglist","cmdgagl",ADMIN_LEVEL_A," - Show gaged IP addresses") 
	register_concmd("amx_ungagip","cmdungagip",ADMIN_LEVEL_A,"<IP address>  - Ungaged IP address") 
	register_concmd("amx_gaglog","cmdgaglog",ADMIN_LEVEL_A," - Show log file") 
	register_clcmd("say","chek")
	register_clcmd("say_team","chek")
	read_list()
}

public cmdgaglog(id)
{
	if (!(get_user_flags(id)&ADMIN_LEVEL_A)) return PLUGIN_CONTINUE
	read_logfile()
	client_print( id , print_notify , "------------- Log file -------------" ) 
	for(new i=0;i<200;i++)
	if(!equal(logs[i],"",0))
	{
		client_print( id , print_notify ,logs[i])
	}
	return PLUGIN_HANDLED	
}


public cmdgag(id)
{
	if (!(get_user_flags(id)&ADMIN_LEVEL_A)) return PLUGIN_CONTINUE  
	new arg[32]
	read_argv(1, arg, 31) 
	if(equal(arg,"",0))
	{
		client_print(id,print_notify,"Enter IP address, please")
		return PLUGIN_HANDLED
	}
	for(new i=0;i<50;i++)
	if(equal(IPs[i],arg,0))
	{
		client_print(id,print_notify,"This IP already gaged")
		return PLUGIN_HANDLED
	}
	for(new i=0;i<50;i++)
	if(equal(IPs[i],"",0))
	{
		IPs[i]=arg
		client_print(id,print_notify,"IP: %s was gaged",arg)
		add_log(id,arg)
		delete_file(ipgaged)
		for(new j=0;j<50;j++)
		if(!equal(IPs[j],"",0))
		{
			write_file(ipgaged,IPs[j],-1)
		}
		return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
} 

public cmdgagl(id)
{
	if (!(get_user_flags(id)&ADMIN_LEVEL_A)) return PLUGIN_CONTINUE
	client_print( id , print_notify , "------------- Gaged IP addresses -------------" ) 
	for(new i=0;i<50;i++)
	if(!equal(IPs[i],"",0))
	{
		client_print( id , print_notify ,IPs[i])
	}
	return PLUGIN_HANDLED	
}

public cmdungagip(id)
{
	if (!(get_user_flags(id)&ADMIN_LEVEL_A)) return PLUGIN_CONTINUE
	new arg[32]
	read_argv(1, arg, 31) 
	if(equal(arg,"",0))
	{
		client_print(id,print_notify,"Enter IP address, please")
		return PLUGIN_HANDLED
	}
	for(new i=0;i<50;i++)
	if(equal(IPs[i],arg,0))
	{
		client_print( id , print_notify ,"IP: %s was removed",arg)
		IPs[i]=""
		rm_log(id,arg)
		delete_file(ipgaged)
		for(new j=0;j<50;j++)
		if(!equal(IPs[j],"",0))
		{
			write_file(ipgaged,IPs[j],-1)
		}
		return PLUGIN_HANDLED
	}
	client_print( id , print_notify ,"IP: %s not found",arg)
	return PLUGIN_HANDLED	
}

public chek(id)
{
	new userip[32]
	get_user_ip(id,userip,31,-1) 
	for(new i=0;i<50;i++)
	if(containi(userip,IPs[i])!=-1)
	{
		client_print( id , print_chat ,"Sorry, you can't speak")
		return PLUGIN_HANDLED
	}	

	return PLUGIN_CONTINUE

}

public read_list() 
{ 
    new index=0, line[32] 
    if (file_exists(ipgaged)) 
    { 
	new length 
	new i
        while(read_file(ipgaged,index,line,32,length)){ 
	    for(i = 0; line[i]; i++) if(line[i] == '^r' || line[i] =='^n') line[i] = 0
            if(line[0]) IPs[index++] = line 
	}
    } 
    else log_message("[AMX] ipgaged file not found") 
    return PLUGIN_CONTINUE 
}

stock add_log(id,const ip[])
{
	new uname[31],Info[70],Time[25]
	get_user_name(id,uname,31)
	get_time("%m/%d/%Y - %H:%M",Time,25)
	format(Info,70,"Admin %s added IP: %s %s",uname,ip,Time)
	write_file(log_file,Info,-1) 
	return PLUGIN_CONTINUE 
}

stock rm_log(id,const ip[])
{
	new uname[31],Info[70],Time[25]
	get_user_name(id,uname,31)
	get_time("%m/%d/%Y - %H:%M",Time,25)
	format(Info,70,"Admin %s removed IP: %s %s",uname,ip,Time)
	write_file(log_file,Info,-1) 
	return PLUGIN_CONTINUE 
}

public read_logfile() 
{ 
    new index=0, line[70] 
    if (file_exists(log_file)) 
    { 
	new length 
	new i
        while(read_file(log_file,index,line,70,length)){ 
	    for(i = 0; line[i]; i++) if(line[i] == '^r' || line[i] =='^n') line[i] = 0
            if(line[0]) logs[index++] = line 
	}
    } 
    else log_message("[AMX] log file not found") 
    return PLUGIN_CONTINUE 
}
